require 'mechanize'

module CiHelper
  class CiProcedure
# this class hardcoding the procedure to the result page

    CI_LOGIN_URL = 'http://ci.raamsys.co.uk/login?from=%2F'
    CI_DOMAIN    = 'http://ci.raamsys.co.uk/'

    attr_accessor :result, :issue_page, :console_page, :matching_strategy, :raam_page
    attr_reader :account, :password, :mechanize, :main_page


    Result = Struct.new(:status, :failures)

    def initialize(account, password)
      @account   = account
      @password  = password
      @mechanize = Mechanize.new
    end

    def run
      @main_page    = login
      @raam_page    = go_to_pull_request_page
      @issue_page   = go_to_issue
      @console_page = go_to_console_output
    end

    def re_get_console_output
      self.raam_page    = go_to_pull_request_page
      self.issue_page   = go_to_issue
      self.console_page = go_to_console_output
      get_console_output
    end

    def get_console_output
      console_page.search("pre.console-output").text
    end

    def issue_number
      branch_name[1..4]
    end

    def branch_name
      issue_link.text.split(' ')[1]
    end

    def commit_hash
      issue_link.text.split(' ')[2]
    end

    private

    def login
      login_page = mechanize.get(CI_LOGIN_URL)

      response_page = login_page.form_with(action: 'j_acegi_security_check') do |form|
        form.fields_with(name: 'j_username').first.value = account
        form.fields_with(name: 'j_password').first.value = password
      end.click_button

      puts 'login success'
      response_page
    end

    def go_to_pull_request_page
      main_page.link_with(text: 'Vansys - pull request').click
    end

    def go_to_develop_page
      main_page.link_with(text: 'Vansys - develop').click
    end

    def go_to_issue
      fail CiHelper::Exceptions::IssueNotFound, 'you may be enter wrong ticket number ' unless issue_link
      issue_link.click
    end

    def go_to_console_output
      issue_page ? issue_page.link_with(text: 'Console Output').click : false
    end

    def issue_link
      links = raam_page.links
      links.select { |link| link.text.match(matching_strategy) }.first
    end
  end
end
