module CiHelper
  module Functions
    class Base
      attr_reader :user_cli, :config,
                  :issue_monitor, :bit_bucket_client,
                  :redmine_client


      def initialize(config)
        @user_cli = CiHelper::UserCommandLineInterface.new
        @config = config

        @issue_monitor     = IssueMonitor.new(config.ci_ac, config.ci_pass)
        @bit_bucket_client = BitBucketProcedure.new(config.bit_ac, config.bit_pass)
        @redmine_client = RedmineProcedure.new(config.redmine_ac, config.redmine_pass)
      end

      def run
        fail NotImplementedError, 'Please implement your function first'
      end
    end
  end
end
