module CiHelper
  module Functions
    class Redmine < Base
      attr_reader :status, :text_box

      # This class responsible for update issue in redmine for one issue or multiple issue
      def run
        @issue_numbers = issue_numbers || user_cli.get_issue_numbers

        issue_numbers.each do |issue_number|
          redmine_client.issue_setting do |config|

            redmine_client.issue_no = issue_number
            puts "issue number : #{issue_number}"

            redmine_client.issue.print_all_status
            config.status           = status || user_cli.get_status
            config.spend_time       =  user_cli.get_spent_time
            config.text_box         = text_box || user_cli.get_more_info
            redmine_client.issue.submit
          end
        end

      end

      def status=(value)
        @status = value
      end

      def text_box=(value)
        @text_box = value
      end

      def issue_numbers=(value)
        @issue_numbers = value
      end

      private

      def multiple_issues?
        issue_numbers.size > 1
      end

      def issue_numbers
        if @issue_numbers.is_a? String
          @issue_numbers.split(' ')
        else
          @issue_numbers
        end
      end
    end
  end
end