module CiHelper
  module Redmine

    #  when include Redmine and you will have issue instance that you can use
    #  before use it to set your form
    #
    #  object.issue_setting do |config|
    #    config.status = 'Your status in text or in value'
    #    config.text_box = 'your description in string'
    #    end
    #
    #  object.issue.submit

    class IssueUpdater

      attr_accessor :update_page, :form

      STATUS = { 1 => 'New', 2 => 'Progress', 3 => 'Resolved', 5 => 'Closed', 8 => 'UT passed', 10 => 'Reopen' ,12 => 'Information Waiting'}
      STATUS_WORKING_FLOW = [1,2,3,8]

      def description
        form.field_with(name: 'issue[subject]').value
      end

      def priority
        # TODO: supply an api for user to pasted the priority of this issue
        fail NotImplementedError, 'not check this method '
        transform_to_word(issue_form.field_with(name: 'issue[prioirty_id]').text.to_i)
      end

      def status=(user_input)
        # make sure let user select value or text
        status_select_list.value = status_options.select { |option| option.value == user_input}
      end

      def text_box=(text)
        text_field.value = text
      end

      def print_all_status
       status_options_in_text.each_index { |index| puts "status: #{status_options_in_text[index]}, value: #{status_options_in_value[index]}"}
      end

      def status_options_in_value
        status_select_list.options.map(&:value)
      end

      def status_options_in_text
        status_select_list.options.map(&:text)
      end

      def target_version
        target_version_select_list.options.select{ |option| option.value == target_version_select_list.value }.first.text
      end

      def target_branch
        target_branch_select_list.options.select{ |option| option.value == target_branch_select_list.value }.first.text
      end

      def spend_time=(time)
        time_entry_hours.value = time
      end

      def submit
        # need to handle the submit success or not
        fail Exceptions::SettingError, 'Please set your form before use it'  unless form

        form.click_button
      end

      private

      def status_options
        status_select_list.options
      end

      def status_select_list
       form.field_with(name: 'issue[status_id]')
      end

      def text_field
        form.field_with(name: 'issue[notes]')
      end

      def target_version_select_list
        form.field_with(name: 'issue[fixed_version_id]')
      end

      def target_branch_select_list
        form.field_with(name: 'issue[custom_field_values][8]')
      end

      def time_entry_hours
        form.field_with(name: 'time_entry[hours]')
      end

      private

      # TODO: not implement yet
      def transform_to_word(id)
        CiHelper::PRIORITY[id]
      end
    end
  end
end