module CiHelper
  # This class responsible for traversing the page in the redmine
  # and find the issue form, re-get the page

  class RedmineProcedure
    # TODO: use this when implement the auto update
    include CiHelper::Redmine
    attr_reader :issue_page, :issue_no, :client, :account, :password


    def initialize(account, password)
      @account  = account
      @password = password
      @client   = Mechanize.new
    end

    def issue_no=(no)
      if issue_no
        @issue_no = no
        refresh_issue_page
        set_issue_form
      else
        @issue_no = no
        login
        set_issue_form
      end
    end

    def set_issue_form
      self.issue_form = form
    end

    def form
      issue_page.form_with(action: "/issues/#{issue_no}")
    end

    def login
      login_page = get_issue_page

      @issue_page = login_page.form_with(action: '/login') do |f|
        f.field_with(name: 'username').value = account
        f.field_with(name: 'password').value = password
      end.click_button
    end

    def refresh_issue_page
      @issue_page = get_issue_page
    end

    def get_issue_page
      client.get("#{CiHelper::REDMINE_DOMAIN}#{issue_no}")
    end

    private

    def transform_to_word(id)
      CiHelper::PRIORITY[id]
    end
  end
end
