module CiHelper
  module RspecResultParser
    class Parser
# This class handle the the result page in the to see the result of test and failures

      attr_reader :fail_examples, :result, :status, :console_output

      def console_output=(output_string)
        @console_output = output_string.split("\n")
        formalize_output
      end

      def success?
        status[0].match('success') ? true : false
      end

      def formalize_output
        fail Exceptions::SettingError, 'Please set the console output first ' unless console_output

        start_index              = nil
        fail_example_start_index = nil
        fail_example_end_index   = nil
        result_index             = false

        console_output.each_index do |index|

          if console_output[index].match('Finished in')
            start_index = index
          elsif console_output[index].match('Failed examples:')
            fail_example_start_index = index
          elsif console_output[index].match('Randomized')
            fail_example_end_index = index
          elsif console_output[index].match('Finished: ')
            result_index = index
          end
        end

        @status        = console_output[start_index, start_index + 1]
        @fail_examples = console_output[fail_example_start_index..fail_example_end_index] if fail_example_start_index
        @result        = result_index
      end
    end
  end
end

