module CiHelper
  class UserCommandLineInterface


    # TODO : need to move to bitbucket related setting to let user set
    REVIEWERS = ['anna_ho_2014', 'cherylyu_jcm',
                 'millieho', 'AlanYu', 'GGD', 'ivan_ho_jcm']

    # this class is responsible for get the user input and print the question message
    attr_accessor :user_answer, :matching_strategy
    attr_reader :issue_monitor

    def wellcome
      puts CiHelper::HELLO_MSG
    end

    def get_user_issue_pattern
      self.matching_strategy = get_user_input do
        puts matching_strategy_question
      end

      matching_strategy
    end


    def wait_issue_finish
      puts waitting_reminder
      sleep(CiHelper::WAITING_TIME)
    end

    def user_want_skip?
      self.user_answer = get_user_input do
        puts issue_not_found_question
        puts 'y\n'
      end

      !user_answer?
    end

    def force_create_pull_request?
      self.user_answer = get_user_input do
        puts fail_test_pull_request_question
        puts 'y\n'
      end

      user_answer?
    end

    def update_issue?
      self.user_answer = get_user_input do
        puts update_issue_question
        puts 'y/n'
      end

      user_answer?
    end

    def user_answer?
      user_answer == 'y' || user_answer == 'Y'
    end

    def get_destination
      get_user_input do
        puts destination_question
      end
    end

    def get_more_info
      get_user_input do
        puts more_info_question
      end
    end

    def get_branch_name
      get_user_input do
        puts branch_name_question
      end
    end

    def customize_title
      get_user_input do
        puts cusotmize_title_question
      end
    end

    def get_user_choose
      get_user_input do
        puts options
      end
    end

    def get_reviewers
      option = get_user_input do
        puts reviewer_question
      end
      # FIXME: the responsibility to transfer the option to bitbucket acceptable params should be the bit_bucket_procedure
      option_to_string(option)
    end

    def get_issue_numbers
      get_user_input do
        puts issue_number_question
      end
    end

    def get_status
      get_user_input do
        puts 'please input status in value'
      end
    end

    def get_spent_time
      get_user_input do
        puts spend_time_question
      end
    end

    def waiting_for_creation
      puts 'Please move your finger away from the enter, and dont keep pushing the fuckkkkkkking enter, I am creating the pf >.^  '
    end

    def print_target(target)
      puts "This is your target branch #{target}\n"
    end

    private

    def get_user_input(&question_block)
      fail CiHelper::Exceptions::NoQuestionError, 'Please assign a question to get user bollean answer' unless question_block

      question_block.call

      return gets.chop
    end

    def option_to_string(option)
      choosen_key = option.split(' ')
      reviewer = []
      choosen_key.each do |value|
        if value.to_i == CiHelper::DANGEROUS
          print_ngyan_cat
          fail Exceptions::SettingError, 'Please dont choose Ciao Bao its dangerous !!!!!!!'
        end

        reviewer << REVIEWERS[value.to_i]
      end

      reviewer.join(',')
    end

    # TODO: extract to a ngyan cat print lib
    def print_ngyan_cat
      puts '              O----O,'
      puts '          :   | 38|\/\                                                       ^^^^'
      puts '          M  ~\___(+.+)'
      puts '               U   U'

    end

    def issue_not_found_question
      'Your issue is queue or enter wrong issue number, do you want to wait the queue?'
    end

    def matching_strategy_question
      'Please Input your next ticket number or commit hash to specify the multi test result in the CI'
    end

    def queueing_question
      'Your issue is queue or enter wrong issue number, do you want to wait the queue?'
    end

    def waitting_reminder
      'Your Issue is running the test now, I will check for you every 60seconds'
    end

    def fail_test_pull_request_question
      "Are You still wanna crete a pull request ? \n Please make sure all the values are all unstable or you will be killed by Gadii >W<"
    end

    def destination_question
      'Please Provide the destination'
    end

    def more_info_question
      'Please Provide the more description you want add in the text box'
    end

    def reviewer_question
      "Please provide the reviewer 0. Anna 1. Cheryl 2. Millie 3.\\\\ Handsome Alan /////4. GGD 5. Ivan 6. CiaoBao order in gender and alphabetically \n EX: 0 1 2 with one space will be Anna, Cherylyu and Millie"
    end

    def branch_name_question
      'Please Provide branch name you want to merge'
    end

    def cusotmize_title_question
      'You branch seems have a lot of issue, please provide your title of pull request'
    end

    def options
      " 1. Monitor issue in CI and create pull request \n
2. input branch name to create pull request \n
3. update issue status \n
please input 1, 2 or 3"
    end

    def issue_number_question
      'please input your ticket number you want to update'
    end

    def update_issue_question
      'Do you want me update the issue for you to ut passed ?'
    end

    def spend_time_question
      'Please input your spent time'
    end
  end
end